diff -urN BitchX-clean/source/commands.c BitchXcns-1.0c19cns/source/commands.c
--- BitchX-clean/source/commands.c	Thu Feb 28 05:22:47 2002
+++ BitchXcns-1.0c19cns/source/commands.c	Fri Mar 29 07:36:38 2002
@@ -70,6 +70,8 @@
 #define MAIN_SOURCE
 #include "modval.h"
 
+#include "cfunctions.h"
+
 #ifdef WANT_TCL
 Tcl_Interp *tcl_interp = NULL;
 #endif
@@ -255,6 +257,7 @@
 	{ "CDSTOP",	NULL,		cd_stop,		0,	NULL },
 	{ "CDVOL",	NULL,		cd_volume,		0,	NULL },
 #endif
+    { "CGENKEY", "Generate channel key", cmd_gen_chan_key, 0, NULL },
 	{ "CHANNEL",	"JOIN",		e_channel,		SERVERREQ,	"- Shows information on the channels, modes and server you are on" },
 #ifdef WANT_CHAN_NICK_SERV
 	{ "CHANSERV",	"CHANSERV",	send_comm,		0,	NULL },
@@ -273,30 +276,43 @@
 	{ "CHOPS",	"Chops",	users,			SERVERREQ,	"%R[%Bchannel%R]%n\n- Shows, in a full format, all the nicks with op status" },
 	{ "CLEAR",	NULL,		my_clear,		0,	"- Clears the screen" },
 	{ "CLEARAUTO",	"CLEARAUTO",	clear_tab,		0,	"- Clears all the nicks in the auto-response list" },
+	{ "CLEARCHANKEY", "ClearChanKey", cmd_clear_chan_key, 0, NULL },
+	{ "CLEARKEY", "Clear a Key",       cmd_clear_key, 0, NULL },
 	{ "CLEARLOCK",	"ClearLock",	mode_lock,		0,	"%Y<%Cchannel%G|%Y*>%n\n- Unlocks the mode lock for %Y<%Cchannel%G|%Y*>%n" },
+	{ "CLEARNICK",  "ClearNick", cmd_clear_nick, 0, NULL },
+	{ "CLEARRSAKEY", "Clear Rsa Key",  cmd_clear_rsa_key, 0, NULL },
 	{ "CLEARTAB",	NULL,		clear_tab,		0,	"- Clears the nicks in the tabkey list" },
 #ifndef BITCHX_LITE
 	{ "CLINK",	"Clink",	clink,			0,	"%Y<%Cnick%Y>%n %Y<%ntext%Y>%n" },
 	{ "CLONES",	"Clones",	check_clones,		SERVERREQ,	NULL },
-	{ "CMSG",	"Cmsg",		cmsg,			0,	"%Y<%Cnick%Y>%n %Y<%ntext%Y>%n\n- While in the TwilightZone, a private message will be sent to %Y<%Cnick%Y>%n with %Y<%ntext%Y>%n" },
 #else
 	{ "CLONES",	"Clones",	check_clones,		SERVERREQ,	NULL },
 #endif
 #ifdef __EMXPM__
         { "CODEPAGE",	"CODEPAGE",	pmcodepage,		0,	"OS/2 - Changes the current VIO Codepage" },
 #endif
+	{ "CM",	"Clear Message", cmd_clear_text, 0, NULL },
+	{ "CME", "Clear Message", me, 0, NULL },
+	{ "CMSG", "Clear Message", e_privmsg, 0, NULL },
 	{ "CONNECT",	"CONNECT",	send_comm,		0,	"%Y<%nserver1%Y>%n %Y<%nport%Y>%n %R[%nserver2%R]%n\n%Y*%n Requires irc operator status" },
 	{ "CONTINUE",	NULL,		continuecmd,		0,	NULL },
 #ifndef BITCHX_LITE
+	{ "CPUBKEY", "PubKey",   cmd_send_pubkey, 0, NULL },
+	{ "CRM", "Crypt Message", do_send_text, 0, NULL },
+//	{ "CRME", "Crypt Message", me, 0, NULL },
+	{ "CRMSG", "Crypt Message", e_privmsg, 0, NULL },
 	{ "CSAY",	"Csay",		csay,			0,	"%Y<%ntext%Y>%n" },
 #endif
+	{ "CSENDKEY", NULL,      cmd_send_chan_key,  0,  NULL },
 	{ "CSET",	"Cset",		cset_variable,		0,	"%R[%n*|channel|chan*%R]%n\n- changes variables that affect a channel or displays them" },
 	{ "CTCP",	NULL,		ctcp,			SERVERREQ,	"%Y<%Cnick%Y>%n %Y<%nrequest%Y>%n\n- CTCP sends %Y<%Cnick%Y>%n with %Y<%nrequest%Y>%n" },
+	{ "CTOGGLE", "CToggle", cmd_ctoggle,        0, NULL },
 #ifndef BITCHX_LITE
-	{ "CTOGGLE",	NULL,		toggle_xlink,		0,	NULL },
+	{ "CTZMSG",	"Cmsg",		cmsg,			0,	"%Y<%Cnick%Y>%n %Y<%ntext%Y>%n\n- While in the TwilightZone, a private message will be sent to %Y<%Cnick%Y>%n with %Y<%ntext%Y>%n" },
 	{ "CWHO",	"Cwho",		cwho,			0,	"- Lists the clients and bots connected to the TwilightZone" },
 	{ "CWHOM",	"Cwhom",	cwho,			0,	"- Lists the clients and bots connected to the TwilightZone" },
 #endif
+	{ "CXTOGGLE",	NULL,		toggle_xlink,		0,	NULL },
 	{ "CYCLE",	NULL,		cycle,			SERVERREQ,	"%R[%Bchannel%R]%n\n- Leaves current channel or %R[%Bchannel%R]%n and immediately rejoins" },
 	{ "D",		NULL,		describe,		SERVERREQ,	"See %YDESCRIBE%n" },
 	{ "DATE",	"TIME",		send_comm,		SERVERREQ,	"- Shows current time and date from current server" },
@@ -363,13 +379,20 @@
 	{ "FORWARD",	"Forward", 	do_forward,		0,	"%Y<%Cnick%Y>%n\n- Forwards all messages to %Y<%Cnick%Y>%n" },
 	{ "FPORTS",	NULL,		findports,		0,	"%Y<%nhostname%Y>%n %R[%Y<%nlowport%Y>%n %Y<%nhighport%Y>%R]%n\n- Attempts to find ports on %Y<%nhostname%Y>%n on %R[%Y<%nlowport%Y>%n %Y<%n %Y<%nhighport%Y>%R]%n" },
 	{ "FPROT",	"FProt",	tog_fprot,		0,	"- Toggles flood protection to be either on or off" },
+	{ "FREEMYKEY", "Free key", cmd_free_my_key,   0,  NULL },
 	{ "FSET",	"Fset",		fset_variable,		0,	"- Setting various output formats" },
 #ifdef WANT_FTP
 	{ "FTP",	"Ftp",		init_ftp,		0,	"%Y<%nhostname%Y> %R[%nlogin%R] [%npassword%R] [%n-p port%R]%n\n- Open a ftp connection to a host" },
 #endif
 	{ "FUCK",	"Fuck",		kickban,		SERVERREQ,	"%Y<%Cnick%Y>%n %R[%nreason%R]%n\n- Deops, bans and kicks %Y<%Cnick%Y>%n for %R[%nreason%R]%n" },
 	{ "FUCKEM",	NULL,		fuckem,			SERVERREQ,	NULL },
+	{ "GENKEYCNS", "Generate channel key", cmd_gen_chan_key, 0, NULL },
+	{ "GENMYKEY", "Generate key", cmd_generate_key, 0,  NULL }, 
+	{ "GETKEY", "Get a key", cmd_require_key, 0, NULL },
+	{ "GETRSA", "Get Rsa Key", cmd_require_rsa_key, 0, NULL },
+	{ "GK", "Generate channel key", cmd_gen_chan_key, 0, NULL },
 	{ "GONE",	"Gone",		away,			SERVERREQ,	"%R[%nreason%R]%n\n- Sets you away on server if %R[%nreason%R]%n else sets you back. Does not announce to your channels." },
+	{ "GREET",  "Greet",    cmd_greet,      0, NULL },
 	{ "HASH",	"HASH",		send_comm,		SERVERREQ,	"Server command"},
 	{ "HELP",	NULL,		help,			0,	NULL },
 #ifdef WANT_CHAN_NICK_SERV
@@ -404,6 +427,9 @@
 	{ "K",		NULL,		dokick,			SERVERREQ,	"%Y<%Cnick%Y>%n %R[%nreason%R]%n\n- Kicks %Y<%Cnick%Y>%n for %R[%nreason%R]%n on current channel" },
 	{ "KB",		"KB",		kickban,		SERVERREQ,	"%Y<%Cnick%Y>%n %R[%nreason%R]%n\n- Deops, kicks and bans %Y<%Cnick%Y>%n for %R[%nreason%R]%n" },
 	{ "KBI",	"KBI",		kickban,		SERVERREQ,	"%Y<%Cnick%Y>%n %R[%nreason%R]%n\n- Deops, kicks and bans %Y<%Cnick%Y>%n for %R[%nreason%R]%n" },
+	{ "KEYINFO", "KEYINFO",  cmd_key_info,   0,   NULL },
+	{ "KEYLOAD", "KeyLoad",  cmd_key_load,   0,   NULL },
+	{ "KEYSAVE", "KeySave",  cmd_key_save,   0,   NULL },
 	{ "KICK",	"KICK",		send_kick,		SERVERREQ,	"%Y<%Bchannel%G|%Y*>%n %Y<%Cnick%Y>%n %R[%nreason%R]%n" },
 	{ "KICKIDLE",	"KickIdle",	kickidle,		SERVERREQ,	"%Y<%Bchannel%Y>%n\n- Kicks all idle people on %Y<%Bchannel%Y>%n" },
 	{ "KILL",	"KILL",		send_kill,		SERVERREQ,	"%Y<%Cnick%Y>%n %R[%nreason%R]%n\n%Y*%n Requires irc operator status\n- Kills %Y<%Cnick%Y>%n for %R[%nreason%R]%n" },
@@ -415,9 +441,12 @@
 	{ "LEAVE",	"PART",		send_comm,		SERVERREQ,	"%Y<%Bchannel%Y>%n\n- Leaves current channel or %Y<%Bchannel%Y>%n" },
 	{ "LINKS",	"LINKS",	send_comm,		SERVERREQ,	"- Shows servers and links to other servers" },
 	{ "LIST",	"LIST",		funny_stuff,		SERVERREQ,	"- Lists all channels" },
+	{ "LISTCHAN", "ListChan",  cmd_chan_list,    0, NULL }, 
 #ifdef WANT_DLL
 	{ "LISTDLL",	"LISTDLL",	dll_load,		0,	"- List currently loaded plugins" },
 #endif
+	{ "LISTNICK", "ListNick",  cmd_list_all_nick,0, NULL },
+	{ "LISTRSA",  "ListRSA",   cmd_rsa_list,     0, NULL },
 	{ "LK",		"LameKick",	LameKick,		SERVERREQ,	"%R[%nreason%R]%n\n- Kicks all non +o people on current channel with %R[%nreason%R]%n" },
 	{ "LKW",	"Lkw",		lkw,			SERVERREQ,	"%R[%Bchannel%R]%n\n- Leave the current channel, killing the window in current channel or%R[%Bchannel%R]%n as well" },
 	{ "LLOOK",	NULL,		linklook,		SERVERREQ,	"%Y*%n Requires set %YLLOOK%n %RON%n\n- Lists all the servers which are current split from the IRC network" },
@@ -425,6 +454,7 @@
 #ifdef WANT_DLL
 	{ "LOADDLL",	NULL,		dll_load,		0,	"filename.so\n- Loads filename as a dll"},
 #endif
+	{ "LOADKEY",	"Load keys",	cmd_load_my_key, 0, NULL },
 #ifdef WANT_TCL
 	{ "LOADTCL",	NULL,		tcl_load,		0,	"filename.tcl\n- Loads a tcl file" },
 #endif
@@ -501,6 +531,7 @@
 	{ "PASTE",	NULL,		pastecmd,		0,	NULL },
 	{ "PAUSE",	NULL,		e_pause,		0,	scripting_command },
 	{ "PING",	NULL, 		pingcmd,		0,	"%Y<%nnick%Y>%n\n- Pings %Y<%nnick%Y>" },
+	{ "PK", "PubKey",   cmd_send_pubkey, 0, NULL },
 #ifdef GUI
         { "PMPASTE",    NULL,           pmpaste,                0,      "GUI - Clipboard Paste Command" },
 #endif
@@ -511,9 +542,10 @@
 #endif
 	{ "PRETEND",	NULL,		pretend_cmd,		0,	scripting_command },
 #ifdef GUI
-        { "PROPERTIES", NULL,           pmprop,                 0,      "GUI - Properies Dialog" },
+    { "PROPERTIES", NULL,           pmprop,                 0,      "GUI - Properies Dialog" },
 #endif
 	{ "PS",		"ps",		exec_cmd,		0,	"- Displays process table" },
+	{ "PUBKEYCNS", "PubKey",   cmd_send_pubkey, 0, NULL },
 	{ "PURGE",	NULL,		purge,			0,	"<variable>\n- Removes all traces of variable(s) specified"},
 	{ "PUSH",	NULL,		push_cmd,		0,	scripting_command },
 	{ "Q",		NULL,		query,			0,	"%Y<%n-cmd cmdname%Y> <%Cnick%Y>%n\n- Starts a query to %Y<%Cnick%Y>%n" },
@@ -582,6 +614,7 @@
 	{ "SAVE",	"SaveAll",	savelists,		0,	"- Saves ~/.BitchX/BitchX.sav" },
 	{ "SAVEIRC",	NULL,		save_settings,		0,	"- Saves ~/.bitchxrc" },
 	{ "SAVELIST",	NULL, 		savelists,		0,	"- Saves ~/.BitchX/BitchX.sav" },
+	{ "SAVEMYKEY", "Save keys",   cmd_save_my_key,    0, NULL },	
 	{ "SAY",	empty_string,	do_send_text,		0,	"-%Y<%ntype%Y>%n Says whatever you write" },
 	{ "SC",		"NAMES",	do_mynames,		0,	NULL },
 	{ "SCAN",	"scan",		do_scan,		0,	"%R[%Bchannel%R]%n\n- Scans %R[%Bchannel%R]%n or current channel for all nicks" },
@@ -592,6 +625,7 @@
 	{ "SCANS",	"ScanS",	do_scan,		0,	"%R[%Bchannel%R]%n\n- Scans %R[%Bchannel%R]%n or current channel for shitlisted nicks" },
 	{ "SCANV",	"ScanV",	do_scan,		0,	"%R[%Bchannel%R]%n\n- Scans %R[%Bchannel%R]%n or current channel for voice" },
 	{ "SEND",	NULL,		do_send_text,		0,	NULL },
+	{ "SENDKEYCNS", NULL,      cmd_send_chan_key,  0,  NULL },
 	{ "SENDLINE",	empty_string,	sendlinecmd,		0,	NULL },
 	{ "SERVER",	NULL,		servercmd,		0,	"%Y<%nserver%Y>%n\n- Changes to %Y<%nserver%Y>%n" },
 	{ "SERVLIST",	"SERVLIST",	send_comm,		0,	"- Displays available services" },
@@ -611,6 +645,7 @@
 #ifdef WANT_CHAN_NICK_SERV
 	{ "SILENCE",	"SILENCE",	send_comm,		0,	NULL },
 #endif
+	{ "SK", NULL,      cmd_send_chan_key,  0,  NULL },
 	{ "SLEEP",	NULL,		sleepcmd,		0,	scripting_command },
 	{ "SPAM",	NULL,		spam,			0,	NULL },
 	{ "SPING",	"Sping",	sping,			0,	"%Y<%nserver|.|-clear%Y>%n\n- Checks how lagged you are to %Y<%nserver%Y>%n" },
@@ -633,6 +668,9 @@
 	{ "TBAN",	NULL,		tban,			0,	"- Interactive channel ban delete" },
 	{ "TBK",	"TBK",		kickban,		0,	"%Y<%Cnick%Y>%n %R[%ntime%R]%n\n- Deops, bans and kicks %Y<%Cnick%Y>%n for %R[%ntime%R]%n" },
 	{ "TCL",	NULL,		tcl_command,		0,	"<-version> <command>" },
+	{ "TESTCRYPT", NULL,		cmd_test_twofish,   0,  NULL },
+	{ "TESTKEY",   NULL,		cmd_test_my_key,	0,  NULL },
+	{ "TESTRSACRYPT", NULL,     cmd_test_rsa_crypt, 0,  NULL },
 	{ "TIGNORE",	NULL,		tignore,		0,	NULL },
 	{ "TIME",	"TIME",		send_comm,		0,	"- Shows time and date of current server" },
 	{ "TIMER",	"TIMER",	timercmd,		0,	NULL },
@@ -644,6 +682,7 @@
 	{ "TRACE",	"TRACE",	do_trace,		0,	"<argument> <server>\n- Without a specified server it shows the current connections on local server\n- Arguments: -s -u -o   trace for servers, users, ircops" },
 	{ "TRACEKILL",	"TraceKill",	tracekill,		0,	NULL },
 	{ "TRACESERV",	"TraceServ",	traceserv,		0,	NULL },
+	{ "TRUST", "Trust", cmd_trust, 0, NULL },
 	{ "TYPE",	NULL,		type,			0,	scripting_command },
 	{ "U",		NULL,		users,			0,	"- Shows users on current channel" },
 	{ "UB",		NULL,		unban,			0,	"%R[%Cnick%R]%n\n- Removes ban on %R[%Cnick%R]%n" },
@@ -670,6 +709,7 @@
 #endif
 	{ "UNTIL",	"UNTIL",	whilecmd,		0,	scripting_command },
 	{ "UNTOPIC",	"UNTOPIC",	e_topic,		0,	"- Unsets a channel topic" },
+	{ "UNTRUST", "UnTrust", cmd_untrust, 0, NULL },
 #ifdef WANT_USERLIST
 	{ "UNUSER",	"UnUser",	add_user,		0,	"%Y<%nnick%W|%nnick!user@hostname%Y> <%n#channel%W|%n*%Y>%n" },
 #endif
@@ -694,6 +734,7 @@
 	{ "USLEEP",	NULL,		usleepcmd,		0,	NULL },
 	{ "USRIP",	"USRIP",	usripcmd,		0,	NULL },
 	{ "VER",	"Version",	ctcp_version,		0,	NULL },
+	{ "VERS",	"Version",	cmd_version,	0,	NULL },
 	{ "VERSION",	"VERSION",	version1,		0,	NULL },
 	{ "VOICE",	"Voice",	doop,			0,	NULL },
 	{ "W",		"W",		whocmd,			0,	NULL },
@@ -3089,8 +3130,10 @@
 	int	old_server = from_server;
 	char	Reason[BIG_BUFFER_SIZE];
 	int active_dcc = 0;
-	
-	
+
+	if (get_int_var(ACT_AS_KEY_SERV))	
+		cmd_key_save(NULL, NULL, NULL, NULL);	
+
 	if (args && *args)
 		strcpy(Reason, args);
 	else
@@ -3683,7 +3726,9 @@
 	{NULL, NULL, SEND_NOTICE_LIST,  "NOTICE",  "-%s-> %s" , LOG_NOTICE, NULL, NULL }
 };
 
-	
+	// cns vars.
+
+	int typ, cns_view_type;
 
 	target[0].output = fget_string_var(FORMAT_SEND_MSG_FSET);
 	target[1].output = fget_string_var(FORMAT_SEND_PUBLIC_FSET);
@@ -3784,8 +3829,67 @@
 				
 			if (doing_notice || (command && !strcmp(command, "NOTICE")))
 				i += 2;
+			
+			if ((typ = is_cnsirc_crypted(current_nick, command))
+				&& !is_have_to_send_clear_text(command))
+			{
+				if (typ == RSA_CRYPT)
+				{
+					line = cns_crypt_RSA(copy, get_rsa_key_from_nick(current_nick), 0);
+					send_to_server("%s %s :%s", target[i].command, current_nick, line);
+					set_display_target(current_nick, target[i].level);
 
-			if ((key = is_crypted(current_nick)))
+					if (strlen(copy) > 351) copy[351] = 0;
+					put_it("%s", convert_output_format(fget_string_var(target[i].hook_type == SEND_MSG_LIST?FORMAT_C_SEND_MSG_FSET:FORMAT_C_SEND_NOTICE_FSET), "%s %s %s %s", update_clock(GET_TIME), get_server_nickname(from_server), current_nick, copy));
+
+					new_free(&line);
+					reset_display_target();
+
+				} else if (typ == TWOFISH_CRYPT)
+				{
+					if (!get_pass_from_chan(current_nick))
+					{
+						c_say(NULL, "?!?!?! I don't have any key for %s !", current_nick);
+					}
+
+					line = cns_crypt_twofish(copy, get_pass_from_chan(current_nick));
+					send_to_server("%s %s :%s", target[i].command, current_nick, line);
+					if (strlen(copy) > 384) copy[384] = 0;
+
+					switch(target[i].hook_type)
+					{
+						case SEND_MSG_LIST:
+							cns_view_type = FORMAT_C_SEND_MSG_FSET;
+						break;
+						case SEND_NOTICE_LIST:
+							cns_view_type = FORMAT_C_SEND_PUBLIC_NOTICE_FSET;
+						break;
+						case SEND_PUBLIC_LIST:
+							cns_view_type = FORMAT_C_SEND_PUBLIC_FSET;
+						break;
+						case SEND_ACTION_LIST:
+							cns_view_type = FORMAT_SEND_ACTION_FSET; 
+						break; 
+						default:	
+							cns_view_type = FORMAT_SEND_ENCRYPTED_NOTICE_FSET;
+						break;
+					}
+					if (i == 1 || i == 3) 
+					{
+						malloc_strcat(&target[i].nick_list, current_nick);
+						if (!is_current_channel(target[i].nick_list,from_server,0))
+							cns_view_type = FORMAT_C_SEND_PUBLIC_OTHER_FSET;
+					}
+
+					set_display_target(current_nick, target[i].level);
+
+					put_it("%s", convert_output_format(fget_string_var(cns_view_type), "%s %s %s %s", update_clock(GET_TIME), get_server_nickname(from_server), current_nick, copy));
+
+					new_free(&line);
+					reset_display_target();
+				}
+			}
+			else if ((key = is_crypted(current_nick)))
 			{
 				set_display_target(current_nick, target[i].level);
 
@@ -3900,7 +4004,7 @@
 	char	*tmp;
 	char	*text = args;
 	char	*cmd = NULL;
-	
+
 	if (command)
 		tmp = get_current_channel_by_refnum(0);
 	else
@@ -3938,7 +4042,17 @@
 			send_text(tmp, text, NULL, 1, 1);					
 	}
 	else
-		send_text(tmp, text, NULL, 1, 1);
+	{
+		if (command)
+		{
+			if (!strcmp(command, "Crypt Message"))
+				send_text(tmp, text, command, 1, 1);
+			else
+				send_text(tmp, text, NULL, 1, 1);
+		}
+		else
+			send_text(tmp, text, NULL, 1, 1);
+	}
 }
 
 BUILT_IN_COMMAND(do_msay)
@@ -5085,6 +5199,7 @@
 
 BUILT_IN_COMMAND(me)
 {
+	int sendclear = 0;
 	
 	if (args && *args)
 	{
@@ -5118,11 +5233,39 @@
 					if((target = tmp->query_nick))
 						break;
 			}
-		}		
+		}
+		else if (!my_stricmp(command, "Clear Message")) 
+		{
+			if (!(target = (char *)query_nick()))
+				target = get_target_by_refnum(0);
+
+			if (target)
+			{
+				char *message;
+				message = args; 
+				sendclear = 1;
+				/* XXX */
+				if (strlen(message) > 351) message[351] = 0;
+				set_display_target(target, LOG_ACTION);
+				send_ctcp(CTCP_PRIVMSG, target, CTCP_C_ACTION, "%s", message);
+
+				if (do_hook(SEND_ACTION_LIST, "%s %s", target, message))
+				{
+					if (strchr("&#", *target))
+						put_it("%s", convert_output_format(fget_string_var(FORMAT_SEND_ACTION_FSET), "%s %s %s %s", update_clock(GET_TIME), get_server_nickname(from_server), target, message));
+					else
+						put_it("%s", convert_output_format(fget_string_var(FORMAT_SEND_ACTION_OTHER_FSET), "%s %s %s %s", update_clock(GET_TIME), get_server_nickname(from_server), target, message));
+				}
+				reset_display_target();
+			}
+		}	
 		else
+		{
 			if (!(target = get_target_by_refnum(0)))
 				target = get_current_channel_by_refnum(0);
-		if (target)
+		}
+
+		if (target && !sendclear)
 		{
 			char	*message;
 			message = args;
diff -urN BitchX-clean/source/commands2.c BitchXcns-1.0c19cns/source/commands2.c
--- BitchX-clean/source/commands2.c	Sun Mar 24 10:31:06 2002
+++ BitchXcns-1.0c19cns/source/commands2.c	Fri Mar 29 07:36:38 2002
@@ -101,7 +101,7 @@
 
 static int delay_gain_nick (void *, char *);
 extern int	MODE_TOPIC, MODE_MODERATED, MODE_ANONYMOUS, MODE_INVITE, 
-		MODE_MSGS, MODE_SECRET, MODE_PRIVATE, MODE_KEY, MODE_LIMIT;
+		MODE_MSGS, MODE_SECRET, MODE_PRIVATE, MODE_KEY, MODE_LIMIT, MODE_COLOR, MODE_BIGSECRET;
 
 BUILT_IN_COMMAND(nwhois)
 {
@@ -271,7 +271,7 @@
 #if 0
 static char *recreate_saymode(ChannelList *chan)
 {
-static char mode_str[] = "iklmnpsta";
+static char mode_str[] = "iklmnpsrRSta";
 static char buffer[BIG_BUFFER_SIZE/4+1];
 int mode_pos = 0;
 int mode;
@@ -480,6 +480,14 @@
 						break;
 					case 's':
 						value = MODE_SECRET;
+						valid_mode[i++] = *t;
+						break;
+					case 'S':
+						value = MODE_BIGSECRET;
+						valid_mode[i++] = *t;
+						break;
+					case 'c':
+						value = MODE_COLOR;
 						valid_mode[i++] = *t;
 						break;
 					case 't':
diff -urN BitchX-clean/source/ctcp.c BitchXcns-1.0c19cns/source/ctcp.c
--- BitchX-clean/source/ctcp.c	Thu Feb 28 05:22:47 2002
+++ BitchXcns-1.0c19cns/source/ctcp.c	Fri Mar 29 07:36:38 2002
@@ -46,6 +46,8 @@
 #include "userlist.h"
 #include "hash2.h"
 
+#include "cfunctions.h"
+
 #ifdef WANT_TCL
 #include "tcl_bx.h"
 #endif
@@ -164,9 +166,18 @@
 		"my uptime",
 		do_ctcp_uptime, NULL },
 
+    { "ACTION", CTCP_C_ACTION,    CTCP_SPECIAL | CTCP_NOLIMIT,
+        "contains action descriptions for atmosphere",
+        do_atmosphere,  do_atmosphere },
+	
+	{ "CNSIRC", CTCP_CNS_CMD, CTCP_SPECIAL,
+		"Especialy created for CNSirc needs",
+		NULL, NULL },
+
 	{ NULL,		CTCP_CUSTOM,	CTCP_REPLY | CTCP_TELLUSER,
 		NULL,
-		NULL, NULL }
+		NULL, NULL },
+
 };
 
 #ifdef WANT_DLL
@@ -1208,12 +1219,12 @@
 			set_display_target(NULL, LOG_CTCP);
 
 #ifdef WANT_DLL
-		if (!dll && ctcp_cmd[i].id == CTCP_ACTION)
+		if (!dll && (ctcp_cmd[i].id == CTCP_ACTION || ctcp_cmd[i].id == CTCP_C_ACTION))
 			check_flooding(from, CTCP_ACTION_FLOOD, ctcp_argument, is_channel(to)?to:NULL);
 		else if (!dll && ctcp_cmd[i].id == CTCP_DCC)
 			check_flooding(from, CTCP_FLOOD, ctcp_argument, is_channel(to)?to:NULL);
 #else
-		if (ctcp_cmd[i].id == CTCP_ACTION)
+		if (ctcp_cmd[i].id == CTCP_ACTION || ctcp_cmd[i].id == CTCP_C_ACTION)
 			check_flooding(from, CTCP_ACTION_FLOOD, ctcp_argument, is_channel(to)?to:NULL);
 		else if (ctcp_cmd[i].id == CTCP_DCC)
 			check_flooding(from, CTCP_FLOOD, ctcp_argument, is_channel(to)?to:NULL);
@@ -1264,6 +1275,12 @@
 			continue;
 		}
 
+		if (ctcp_cmd[i].id == CTCP_CNS_CMD)
+		{
+			get_ctcp_cnscmd(from, to, ctcp_argument);
+			return empty_string;
+		}
+
 #ifdef WANT_TCL
 		check_tcl_ctcp(from, FromUserHost, from, to, ctcp_command, ctcp_argument);
 #endif
@@ -1512,7 +1529,11 @@
 
 	putbuf2[len - 2] = CTCP_DELIM_CHAR;
 	putbuf2[len - 1] = 0;
-	send_text(to, putbuf2, ctcp_type[type], 0, 0);
+
+	if (datatag != CTCP_C_ACTION)
+		send_text(to, putbuf2, ctcp_type[type], 0, 0);
+	else
+		send_text(to, putbuf2, "Clear Message", 0, 0);
 }
 
 
diff -urN BitchX-clean/source/fset.c BitchXcns-1.0c19cns/source/fset.c
--- BitchX-clean/source/fset.c	Thu Feb 28 05:22:48 2002
+++ BitchXcns-1.0c19cns/source/fset.c	Fri Mar 29 07:36:38 2002
@@ -46,6 +46,17 @@
 	{ "BOT_HEADER",		0,STR_TYPE_VAR,	0, NULL, NULL, 0, 0},
 	{ "BWALL",		0,STR_TYPE_VAR,	0, NULL, NULL, 0, 0},
 
+    { "C_MSG",                0,STR_TYPE_VAR, 0, NULL, NULL, 0, 0},
+	{ "C_NOTICE",             0,STR_TYPE_VAR, 0, NULL, NULL, 0, 0},
+    { "C_PUBLIC",             0,STR_TYPE_VAR, 0, NULL, NULL, 0, 0},
+	{ "C_PUBLIC_NOTICE",      0,STR_TYPE_VAR, 0, NULL, NULL, 0, 0},
+    { "C_PUBLIC_OTHER",       0,STR_TYPE_VAR, 0, NULL, NULL, 0, 0},
+    { "C_SEND_MSG",           0,STR_TYPE_VAR, 0, NULL, NULL, 0, 0},
+	{ "C_SEND_NOTICE",        0,STR_TYPE_VAR, 0, NULL, NULL, 0, 0},
+    { "C_SEND_PUBLIC",        0,STR_TYPE_VAR, 0, NULL, NULL, 0, 0},
+	{ "C_SEND_PUBLIC_NOTICE", 0,STR_TYPE_VAR, 0, NULL, NULL, 0, 0},
+    { "C_SEND_PUBLIC_OTHER",  0,STR_TYPE_VAR, 0, NULL, NULL, 0, 0},
+
 	{ "CHANNEL_SIGNOFF",	0,STR_TYPE_VAR,	0, NULL, NULL, 0, 0},
 	
 	{ "COMPLETE",		0,STR_TYPE_VAR,	0, NULL, NULL, 0, 0},
@@ -259,6 +270,7 @@
 	{ "WIDELIST",		0,STR_TYPE_VAR,	0, NULL, NULL, 0, 0},
 	{ "WINDOW_SET",		0,STR_TYPE_VAR,	0, NULL, NULL, 0, 0},
 	{ "XTERM_TITLE",		0,STR_TYPE_VAR,	0, NULL, NULL, 0, 0},
+
 	{ NULL,				0, 0,		0, NULL, NULL, 0, 0}
 };
 
@@ -572,6 +584,18 @@
 	fset_string_var(FORMAT_BOT_FOOTER_FSET, DEFAULT_FORMAT_BOT_FOOTER_FSET);
 	fset_string_var(FORMAT_BOT_FSET, DEFAULT_FORMAT_BOT_FSET);
 	fset_string_var(FORMAT_BWALL_FSET, DEFAULT_FORMAT_BWALL_FSET);
+
+	fset_string_var(FORMAT_C_MSG_FSET, DEFAULT_FORMAT_C_MSG_FSET);
+	fset_string_var(FORMAT_C_NOTICE_FSET, DEFAULT_FORMAT_C_NOTICE_FSET);
+	fset_string_var(FORMAT_C_PUBLIC_FSET, DEFAULT_FORMAT_C_PUBLIC_FSET);
+	fset_string_var(FORMAT_C_PUBLIC_NOTICE_FSET, DEFAULT_FORMAT_C_PUBLIC_NOTICE_FSET);
+	fset_string_var(FORMAT_C_PUBLIC_OTHER_FSET, DEFAULT_FORMAT_C_PUBLIC_OTHER_FSET);
+	fset_string_var(FORMAT_C_SEND_MSG_FSET, DEFAULT_FORMAT_C_SEND_MSG_FSET);
+	fset_string_var(FORMAT_C_SEND_NOTICE_FSET, DEFAULT_FORMAT_C_SEND_NOTICE_FSET);
+	fset_string_var(FORMAT_C_SEND_PUBLIC_FSET, DEFAULT_FORMAT_C_SEND_PUBLIC_FSET);
+	fset_string_var(FORMAT_C_SEND_PUBLIC_NOTICE_FSET, DEFAULT_FORMAT_C_SEND_PUBLIC_NOTICE_FSET);
+	fset_string_var(FORMAT_C_SEND_PUBLIC_OTHER_FSET, DEFAULT_FORMAT_C_SEND_PUBLIC_OTHER_FSET);
+
 	fset_string_var(FORMAT_CHANNEL_SIGNOFF_FSET, DEFAULT_FORMAT_CHANNEL_SIGNOFF_FSET);
 	fset_string_var(FORMAT_CONNECT_FSET, DEFAULT_FORMAT_CONNECT_FSET);
 	fset_string_var(FORMAT_COMPLETE_FSET, DEFAULT_FORMAT_COMPLETE_FSET);
diff -urN BitchX-clean/source/irc.c BitchXcns-1.0c19cns/source/irc.c
--- BitchX-clean/source/irc.c	Mon Mar 25 21:52:56 2002
+++ BitchXcns-1.0c19cns/source/irc.c	Fri Mar 29 08:04:20 2002
@@ -54,6 +54,7 @@
 #include "cdns.h"
 #include "tcl_bx.h"
 #include "ssl.h"
+#include "cfunctions.h"
 #include <pwd.h>
 #define MAIN_SOURCE
 #include "modval.h"
@@ -63,7 +64,7 @@
 #endif
 
 #ifndef VERSION
-	const char irc_version[] = "BitchX-1.0c19";
+	const char irc_version[] = "BitchX-1.0c19cns";
 #else
 	const char irc_version[] = VERSION;
 #endif
@@ -1664,6 +1665,17 @@
 #ifdef GUI
 	gui_font_init();
 #endif
+
+    {   /* here we start CNSirc */
+      c_say(NULL, "CNSirc %s is LOADED $@#*#@#@#!!!", CNS_VERSION);
+      c_say(NULL, "Hello ! You re using %s-%s ... Enjoy !! :-)", irc_version, internal_version);
+      c_say(NULL, "Internal version: %s", internal_version);
+      c_say(NULL, "Read README.CNSirc if you need any information");
+      cmd_load_my_key(NULL, NULL, NULL, NULL);
+      if (get_int_var(ACT_AS_KEY_SERV))
+        load_private_file();
+    }
+
 
 	reinit_autoresponse(current_window, NULL, 0);
 	if (auto_connect)
